diff --git a/tests/data/uefi-boot-images/bios-tables-test.riscv64.iso.qcow2 b/tests/data/uefi-boot-images/bios-tables-test.riscv64.iso.qcow2
new file mode 100644
index 0000000000000000000000000000000000000000..c720bf99a45fab6d1e21963cca563ee0ea059b82
GIT binary patch
diff --git a/tests/uefi-test-tools/uefi-test-build.config b/tests/uefi-test-tools/uefi-test-build.config
index 1f389ae541..a4c61fc97a 100644
--- a/tests/uefi-test-tools/uefi-test-build.config
+++ b/tests/uefi-test-tools/uefi-test-build.config
@@ -24,7 +24,7 @@ cpy1 = AARCH64/BiosTablesTest.efi  bios-tables-test.aarch64.efi
 ####################################################################################
 # riscv64
 
-[build.riscv]
+[build.riscv64]
 conf = UefiTestToolsPkg/UefiTestToolsPkg.dsc
 plat = UefiTestTools
 dest = ./Build